=== modified file 'src/com/goldencode/p2j/oo/reflect/Variable.java'
--- src/com/goldencode/p2j/oo/reflect/Variable.java	2021-02-21 16:25:50 +0000
+++ src/com/goldencode/p2j/oo/reflect/Variable.java	2021-10-28 07:59:30 +0000
@@ -8,6 +8,7 @@
 ** 001 ME  20200422 First version.
 ** 002 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                  signature.
+**     ME  20211028 Use 'POLY' data type for get/set methods.
 */
 
 /*
@@ -66,7 +67,6 @@
 package com.goldencode.p2j.oo.reflect;
 
 import com.goldencode.p2j.util.*;
-
 import static com.goldencode.p2j.report.ReportConstants.*;
 import static com.goldencode.p2j.util.BlockManager.*;
 import static com.goldencode.p2j.util.InternalEntry.Type;
@@ -191,40 +191,40 @@
       }));
    }
 
-   @LegacySignature(returns = "OBJECT", type = Type.METHOD, name = "Get", extent = -1, qualified = "progress.lang.object")
-   public object<? extends _BaseObject_>[] get()
+   @LegacySignature(type = Type.METHOD, name = "Get", returns = "BDT")
+   public Object get()
    {
       return extentFunction(Variable.class, this, "Get", object.class, new Block());
    }
 
-   @LegacySignature(returns = "OBJECT", type = Type.METHOD, name = "Get", extent = -1, qualified = "progress.lang.object", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "Get", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "index", type = "INTEGER", mode = "INPUT")
    })
-   public object<? extends _BaseObject_>[] get(final integer _index)
+   public Object get(final integer _index)
    {
       integer index = TypeFactory.initInput(_index);
       
       return extentFunction(Variable.class, this, "Get", object.class, new Block());
    }
 
-   @LegacySignature(returns = "OBJECT", type = Type.METHOD, name = "Get", extent = -1, qualified = "progress.lang.object", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "Get", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "instance", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT")
    })
-   public object<? extends _BaseObject_>[] get(final object<? extends _BaseObject_> _instance)
+   public Object get(final object<? extends _BaseObject_> _instance)
    {
       object<? extends _BaseObject_> instance = TypeFactory.initInput(_instance);
       
       return extentFunction(Variable.class, this, "Get", object.class, new Block());
    }
 
-   @LegacySignature(returns = "OBJECT", type = Type.METHOD, name = "Get", extent = -1, qualified = "progress.lang.object", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "Get", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "instance", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT"),
       @LegacyParameter(name = "index", type = "INTEGER", mode = "INPUT")
    })
-   public object<? extends _BaseObject_>[] get(final object<? extends _BaseObject_> _instance, final integer _index)
+   public Object get(final object<? extends _BaseObject_> _instance, final integer _index)
    {
       object<? extends _BaseObject_> instance = TypeFactory.initInput(_instance);
       integer index = TypeFactory.initInput(_index);
@@ -232,55 +232,51 @@
       return extentFunction(Variable.class, this, "Get", object.class, new Block());
    }
 
-   @LegacySignature(type = Type.METHOD, name = "Set", parameters = 
-   {
-      @LegacyParameter(name = "value", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT")
-   })
-   public void set(final object<? extends _BaseObject_> _value)
-   {
-      object<? extends _BaseObject_> value = TypeFactory.initInput(_value);
-      
-      internalProcedure(Variable.class, this, "Set", new Block());
-   }
-
-   @LegacySignature(type = Type.METHOD, name = "Set", parameters = 
-   {
-      @LegacyParameter(name = "index", type = "INTEGER", mode = "INPUT"),
-      @LegacyParameter(name = "value", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT")
-   })
-   public void set(final integer _index, final object<? extends _BaseObject_> _value)
-   {
-      integer index = TypeFactory.initInput(_index);
-      object<? extends _BaseObject_> value = TypeFactory.initInput(_value);
-      
-      internalProcedure(Variable.class, this, "Set", new Block());
-   }
-
-   @LegacySignature(type = Type.METHOD, name = "Set", parameters = 
-   {
-      @LegacyParameter(name = "instance", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT"),
-      @LegacyParameter(name = "value", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT")
-   })
-   public void set(final object<? extends _BaseObject_> _instance, final object<? extends _BaseObject_> _value)
-   {
-      object<? extends _BaseObject_> instance = TypeFactory.initInput(_instance);
-      object<? extends _BaseObject_> value = TypeFactory.initInput(_value);
-      
-      internalProcedure(Variable.class, this, "Set", new Block());
-   }
-
-   @LegacySignature(type = Type.METHOD, name = "Set", parameters = 
-   {
-      @LegacyParameter(name = "instance", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT"),
-      @LegacyParameter(name = "index", type = "INTEGER", mode = "INPUT"),
-      @LegacyParameter(name = "value", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT")
-   })
-   public void set(final object<? extends _BaseObject_> _instance, final integer _index, final object<? extends _BaseObject_> _value)
-   {
-      object<? extends _BaseObject_> instance = TypeFactory.initInput(_instance);
-      integer index = TypeFactory.initInput(_index);
-      object<? extends _BaseObject_> value = TypeFactory.initInput(_value);
-      
-      internalProcedure(Variable.class, this, "Set", new Block());
-   }
+   
+   @LegacySignature(type = Type.METHOD, name = "Set", parameters = 
+   {
+      @LegacyParameter(name = "value", type = "BDT", mode = "INPUT")
+   })
+   public void set(final Object _value)
+   {
+   }
+
+   @LegacySignature(type = Type.METHOD, name = "Set", parameters = 
+   {
+      @LegacyParameter(name = "index", type = "INTEGER", mode = "INPUT"),
+      @LegacyParameter(name = "value", type = "BDT", mode = "INPUT")
+   })
+   public void set(final integer _index, final Object _value)
+   {
+      integer index = TypeFactory.initInput(_index);
+      
+      internalProcedure(Variable.class, this, "Set", new Block());
+   }
+
+   @LegacySignature(type = Type.METHOD, name = "Set", parameters = 
+   {
+      @LegacyParameter(name = "instance", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT"),
+      @LegacyParameter(name = "value", type = "BDT", mode = "INPUT")
+   })
+   public void set(final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _instance, final Object _value)
+   {
+      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> instance = TypeFactory.initInput(_instance);
+      
+      internalProcedure(Variable.class, this, "Set", new Block());
+   }
+   
+   @LegacySignature(type = Type.METHOD, name = "Set", parameters = 
+   {
+      @LegacyParameter(name = "instance", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT"),
+      @LegacyParameter(name = "index", type = "INTEGER", mode = "INPUT"),
+      @LegacyParameter(name = "value", type = "BDT", mode = "INPUT")
+   })
+   public void set(final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _instance, final integer _index, Object _value)
+   {
+      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> instance = TypeFactory.initInput(_instance);
+      integer index = TypeFactory.initInput(_index);
+      
+      internalProcedure(Variable.class, this, "Set", new Block());
+   }
+   
 }

=== modified file 'src/com/goldencode/p2j/pattern/CommonAstSupport.java'
--- src/com/goldencode/p2j/pattern/CommonAstSupport.java	2021-12-21 18:55:52 +0000
+++ src/com/goldencode/p2j/pattern/CommonAstSupport.java	2022-02-11 15:26:27 +0000
@@ -267,6 +267,7 @@
 **     HC  20211001          Implementation of i18n support.
 **     CA  20211012          Fixed generated WSDL and reworked SOAP support to rely on namespace, when
 **                           resolving an operation.
+**     ME  20211025          Added AST node as input to loadConvertedClass method.
 **     CA  20211214          The AST manager plugin must be context-local, for runtime conversion, as the 
 **                           InMemoryRegistryPlugin is not thread-safe.
 **                           All worker's state must be context-local, for runtime conversion to work in 
@@ -620,15 +621,20 @@
        * @param    isNew
        *           Flag indicating that this is a new class (now being parsed), or a previously
        *           converted class.
+       * @param    ast 
+       *           The abstract syntax tree node.
        *           
        * @return   See above.
        * 
        * @throws   ClassNotFoundException
        *           If the class can't be resolved or loaded.
        */
-      public ConvertedClassName loadConvertedClass(String filename, boolean isNew)
-      throws ClassNotFoundException
+      public ConvertedClassName loadConvertedClass(String filename, boolean isNew, Aast ast)
+               throws ClassNotFoundException
       {
+         if (filename == null)
+            throw new ClassNotFoundException(
+                     "Can not find class for accessing " + ast.toStringVerbose());
          return SymbolResolver.loadConvertedClass(filename, isNew);
       }
       

=== modified file 'src/com/goldencode/p2j/uast/ClassDefinition.java'
--- src/com/goldencode/p2j/uast/ClassDefinition.java	2022-01-28 14:01:01 +0000
+++ src/com/goldencode/p2j/uast/ClassDefinition.java	2022-02-11 15:26:27 +0000
@@ -106,6 +106,7 @@
 **     GES 20210702          Allow parent hierarchy lookup for static methods.  This is a 4GL quirk that is not
 **                           present in Java. See #4978.  Removed dead code and some debugging code. Improved
 **                           support for .NET arrays and .NET generic type parameters.
+**     ME  20211028          Add support for 'virtual' POLY data type on methods return/parameters.
 **     OM  20211122          Added hints-based support for 'unloading' schema.
 **     CA  20220128          Added a NPE protection for exactMethodLookup(), seen in incremental conversion, 
 **                           but with no local duplicate.
@@ -1605,22 +1606,11 @@
          
          if (mdat != null)
          {
-            if (mdat.name.equalsIgnoreCase("invoke") && 
-                (mdat.container.name.equalsIgnoreCase("progress.lang.class") || 
-                 mdat.container.name.equalsIgnoreCase("progress.reflect.method")))
-            {
-               // set the node's type to OO_METH_POLY
-               node.putAnnotation("oldtype", (long) node.getType());
-               node.setType(OO_METH_POLY);
-            }
-            else
-            {
-               // the type may have been set incorrectly based on guessing, since the parameter
-               // signature was not yet available; force it to the correct value here
-               if (node.getType() != FUNC_CLASS)
-               {
-                  node.setType(mdat.type);
-               }
+            // the type may have been set incorrectly based on guessing, since the parameter
+            // signature was not yet available; force it to the correct value here
+            if (node.getType() != FUNC_CLASS)
+            {
+               node.setType(mdat.type);
             }
             
             // the access mode won't necessarily be the same as that passed in
@@ -2916,7 +2906,8 @@
                         }
                      }
                      else if ((!nowrapObjects || !classname.startsWith("object<")) && 
-                              !classname.startsWith("jobject<"))
+                              !classname.startsWith("jobject<") && 
+                              !classname.equals("BaseDataType") && !classname.equals("Object"))
                      {
                         // TODO: CA: what's the reas for nowrapObjects?
                         parm.putAnnotation("wrap_parameter", Boolean.TRUE);
@@ -3428,7 +3419,8 @@
                // unknown value or BDT (POLY cases) match anything
                if (callerType == null                     ||
                    callerType.equals("BaseDataType")      ||
-                   callerType.equals("unknown"))
+                   callerType.equals("unknown")           || 
+                   candidateType.equals("Object"))
                {
                   exact = false;
                   continue inner;

=== modified file 'src/com/goldencode/p2j/uast/SymbolResolver.java'
--- src/com/goldencode/p2j/uast/SymbolResolver.java	2022-01-28 14:01:01 +0000
+++ src/com/goldencode/p2j/uast/SymbolResolver.java	2022-02-11 15:26:27 +0000
@@ -452,6 +452,7 @@
 **     GES 20210715          Added loadConvertedClassByQname().
 **     CA  20210920          Added NPE protection for some registries, for runtime conversion.
 **     HC  20211001          Implementation of i18n support.
+**     ME  20211026          Added support for POLY data type.
 **     OM  20211122          Added hints-based support for 'unloading' schema.
 **     CA  20220113          Widget lookup must not be performed (and return 'no match') if the closest 
 **                           definition is a variable which can't be a widget (HANDLE, object, etc).
@@ -1792,6 +1793,9 @@
          case VAR_ROWID:
             cls = "rowid";
             break;
+         case VAR_POLY:
+            cls = "Object";
+            break;
          case VAR_CLASS:
             cls = "object";
             if (parm != null)

=== modified file 'src/com/goldencode/p2j/uast/progress.g'
--- src/com/goldencode/p2j/uast/progress.g	2022-01-18 07:06:00 +0000
+++ src/com/goldencode/p2j/uast/progress.g	2022-02-11 15:26:27 +0000
@@ -2207,6 +2207,7 @@
 **     SVL 20210804          DB-FIELD-MAPPING is replaced with DB-{SORT|FILTER}-FIELD-MAPPING.
 **     SVL 20210806          Added DISABLE-USER-CFG-EDIT and DISABLE-ROW-STRIPING as attributes.
 **     SVL 20210814          Changed DISABLE-USER-CFG-EDIT to DISABLE-CFG-EDIT.
+**     ME  20211025          Added package protected/private and POLY data type.
 **     HC  20211201          Implemented TREEVIEW:CHECK-BOXES attribute. Added NODE-CHECK
 **                           TREEVIEW trigger.
 **     VVT 20211203          Added KW_CODE_STATE keyword. See #5850-20.
@@ -2966,6 +2967,7 @@
          VAR_RECID;
          VAR_ROWID;
          SYS_HANDLE;
+         VAR_POLY;
          BEGIN_NATIVE_VARTYPES;
             VAR_BYTE;
             VAR_DOUBLE;
@@ -3052,6 +3054,7 @@
          METH_LOGICAL;
          METH_LONGCHAR;
          METH_MEMPTR;
+         METH_POLY;
          METH_RAW;
          METH_RECID;
          METH_ROWID;
@@ -4633,6 +4636,9 @@
       KW_PICK_BTH;
       KW_PIX_COL;
       KW_PIX_ROW;
+      KW_PK_PRIVATE;
+      KW_PK_PROTECTD;
+      KW_POLY;
       KW_POP_MENU;
       KW_POP_ONLY;
       KW_PORTRAIT;
@@ -9817,7 +9823,8 @@
           sec != KW_FLOAT    &&
           sec != KW_LONG     &&
           sec != KW_SHORT    &&
-          sec != KW_UNS_SHRT)
+          sec != KW_UNS_SHRT &&
+          sec != KW_POLY)
       {
          String text    = LT(lookahead).getText().toLowerCase();
          int    newtype = -1;
@@ -10422,6 +10429,7 @@
          case KW_SHORT:
          case KW_UNS_LONG:
          case KW_UNS_SHRT:
+         case KW_POLY:
             return true;
       }
       
@@ -12608,12 +12616,12 @@
    ;
    
 /**
- * Matches <code>KW_PUBLIC</code>, <code>KW_PROTECTD</code> or
- * <code>KW_PRIVATE</code>.
+ * Matches <code>KW_PUBLIC</code>, <code>KW_PROTECTD</code>,
+ * <code>KW_PRIVATE</code>, <code>KW_PK_PROTECTD</code> or  <code>KW_PK_PRIVATE</code>.
  */
 access_mode
    :
-      KW_PUBLIC | KW_PROTECTD | KW_PRIVATE
+      KW_PUBLIC | KW_PROTECTD | KW_PRIVATE  | KW_PK_PROTECTD | KW_PK_PRIVATE
    ;
    
 /**
@@ -12782,6 +12790,7 @@
                                    { mtype = OO_METH_LOGICAL; }
          | KW_LONGCHAR             { mtype = OO_METH_LONGCHAR; }
          | KW_MEMPTR               { mtype = OO_METH_MEMPTR; }
+         | KW_POLY                 { mtype = OO_METH_POLY; }
          | KW_RAW                  { mtype = OO_METH_RAW; }
          | KW_RECID                { mtype = OO_METH_RECID; }
          | KW_ROWID                { mtype = OO_METH_ROWID; }
@@ -13184,6 +13193,7 @@
          | KW_WID_HAND                                          { ftype = FUNC_HANDLE; }
          | KW_RAW                                               { ftype = FUNC_RAW; }
          | KW_MEMPTR                                            { ftype = FUNC_MEMPTR; }
+         | KW_POLY                                              { ftype = FUNC_POLY; }
          | (
               options { generateAmbigWarnings = false; }
               :
@@ -23481,6 +23491,7 @@
          | KW_ROWID                             { vartype = VAR_ROWID; }
          | KW_RAW                               { vartype = VAR_RAW; }
          | KW_MEMPTR                            { vartype = VAR_MEMPTR; }
+         | KW_POLY                              { vartype = VAR_POLY; }
          
            // support the native types if necessary
          | { nativeTypes }?
@@ -31836,6 +31847,7 @@
  *   VAR_RECID
  *   VAR_ROWID
  *   SYS_HANDLE
+ *   VAR_POLY
  *   CLASS_NAME (static OO 4GL class reference)
  *   VAR_BYTE
  *   VAR_DOUBLE
@@ -32269,6 +32281,7 @@
               | VAR_RAW^
               | VAR_RECID^   
               | VAR_ROWID^
+              | VAR_POLY^
               
               // native interface types
               | VAR_BYTE^      | VAR_DOUBLE^  | VAR_FLOAT^   | VAR_LONG^
@@ -35389,6 +35402,8 @@
          new Keyword("owner"                          ,  0, KW_OWNER   , false),
          new Keyword("owner-document"                 ,  0, KW_OWN_DOC , false),
          new Keyword("p2j-remote-call"                ,  0, KW_P2J_RC  , false),  // P2J-extension, not real 4GL!
+         new Keyword("package-private"                ,  0, KW_PK_PRIVATE, false),
+         new Keyword("package-protected"              ,  0, KW_PK_PROTECTD, false),
          new Keyword("page"                           ,  0, KW_PAGE    , true ),
          new Keyword("paged"                          ,  0, KW_PAGED   , false),
          new Keyword("page-bottom"                    ,  8, KW_PAGE_B  , true ),
@@ -35430,6 +35445,7 @@
          new Keyword("pixels"                         ,  0, KW_PIXELS  , true ),
          new Keyword("pixels-per-column"              , 14, KW_PIX_COL , false),
          new Keyword("pixels-per-row"                 ,  0, KW_PIX_ROW , false),
+         new Keyword("_BDT_"                          ,  0, KW_POLY    , false),
          new Keyword("portrait"                       ,  0, KW_PORTRAIT, false),
          new Keyword("position"                       ,  7, KW_POS     , false),
          new Keyword("popup-menu"                     ,  7, KW_POP_MENU, false),


=== modified file 'src/com/goldencode/p2j/util/Call.java'
--- src/com/goldencode/p2j/util/Call.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/util/Call.java	2022-02-14 08:50:25 +0000
@@ -29,6 +29,7 @@
 **                  Reworked INPUT/INPUT-OUTPUT parameters to a new approach, where they are explicitly 
 **                  initialized at the method's execution, and not at the caller's arguments.
 **     CA  20220120 Do not used TypeFactory.object when the OO reference must not be tracked or registered.
+**     ME  20220214 Fix variable class type check for block's inline variables.
 */
 
 /*
@@ -2274,6 +2275,10 @@
                   valueCls = _BaseObject_.class;
                }
             }
+            else if (value instanceof BaseDataType)
+            {
+               valueCls = ((BaseDataType) value).getType().getCls();
+            }
             
             if ((valueCls.isAssignableFrom(memptr.class)) && !"MEMPTR".equalsIgnoreCase(dataType)
                      || ("MEMPTR".equalsIgnoreCase(dataType) && !(valueCls.isAssignableFrom(memptr.class))))

